#ifndef SFFORM_H
#define SFFORM_H

#include "BaseDialog.h"
#include "tstring.h"

class CSfForm : public BaseDialog {
private:
	TwrWnd *editSf1;
	TwrWnd *editSf2;
	TwrWnd *chkSf1;
	TwrWnd *chkSf2;
	TwrWnd *ignoreToolbarSf1;
	TwrWnd *ignoreToolbarSf2;

	void OnBnClickedRefsf1();
	void OnBnClickedRefsf2();
	void OnBnClickedButtonsearchsf31();
	void OnBnClickedButtonsearchsf32();

	bool confirm(HWND hWnd,tstring &bookmark,int pos);
	tstring GetBookmark();

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_SfBM1;
	// ubN}[Ñt@C2
	tstring m_SfBM2;
	BOOL m_chkSf1;
	BOOL m_chkSf2;
	// ubN}[No[𖳎邩ǂ1
	BOOL m_chkIgnoreToolbar1;
	// ubN}[No[𖳎邩ǂ2
	BOOL m_chkIgnoreToolbar2;

	CSfForm(HWND parent, int resource);
	~CSfForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchSf1(HWND hWnd);
	void searchSf2(HWND hWnd);
};

#endif // SFFORM_H

