#ifndef XBFORM_H
#define XBFORM_H

#include "BaseDialog.h"
#include "tstring.h"
#include "TwrCombobox.h"

class CXbForm : public BaseDialog {
private:
	TwrWnd *editXb1;
	TwrWnd *editXb2;
	TwrWnd *chkXb1;
	TwrWnd *chkXb2;
	TwrWnd *ignoreToolbarXb1;
	TwrWnd *ignoreToolbarXb2;
	TwrCombobox *layoutXb1;
	TwrCombobox *layoutXb2;

	void OnBnClickedRefxb1();
	void OnBnClickedRefxb2();
	void OnBnClickedCheckxb1();
	void OnBnClickedCheckxb2();
	void OnCbnSelchangeComboLayoutXb1();
	void OnCbnSelchangeComboLayoutXb2();

	void SetXb1Enable();
	void SetXb2Enable();

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_XbBM1;
	// ubN}[Ñt@C2
	tstring m_XbBM2;
	// t@C1̓sǂ
	BOOL m_chkXb1;
	// t@C2̓sǂ
	BOOL m_chkXb2;
	// t@C1̃CAEg
	int m_LayoutXb1;
	// t@C2̃CAEg
	int m_LayoutXb2;
	BOOL m_chkIgnoreToolbar1;
	BOOL m_chkIgnoreToolbar2;

	CXbForm(HWND parent, int resource);
	~CXbForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);
};

#endif // XBFORM_H

