#ifndef CHFORM_H
#define CHFORM_H

#include "BaseDialog.h"
#include "tstring.h"
#include "TJson.h"

class CChForm : public BaseDialog {
private:
	TwrWnd *editCh1;
	TwrWnd *editCh2;
	TwrWnd *chkCh1;
	TwrWnd *chkCh2;
	TwrWnd *ignoreToolbarCh1;
	TwrWnd *ignoreToolbarCh2;

	void OnBnClickedRefch1();
	void OnBnClickedRefch2();
	void OnBnClickedButtonsearchch1();
	void OnBnClickedButtonsearchch2();

	void SetCh1Enable();
	void SetCh2Enable();
	tstring GetBookmark(HWND hWnd, int pos, tstring exclude);
	tstring searchProfile(
		HWND hWnd,
		TJson *jsonObj,
		TCHAR *profiles,
		int pos,
		tstring basePath,
		tstring exclude);

protected:
	INT_PTR CChForm::OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);
public:
	// ChromẽubN}[N1̃t@C
	tstring m_ChBM1;
	// ChromẽubN}[N2̃t@C
	tstring m_ChBM2;
	// ChromẽubN}[N1𓯊邩ǂ
	BOOL m_chkCh1;
	// ChromẽubN}[N2𓯊邩ǂ
	BOOL m_chkCh2;
	// ubN}[No[𖳎邩ǂ1
	BOOL m_chkIgnoreToolbar1;
	// ubN}[No[𖳎邩ǂ2
	BOOL m_chkIgnoreToolbar2;

	CChForm(HWND parent, int resource);
	CChForm::~CChForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchCh1(HWND hWnd);
	void searchCh2(HWND hWnd);

};

#endif // CHFORM_H

