#ifndef FXFORM_H
#define FXFORM_H

#include "BaseDialog.h"
#include "tstring.h"

class CFxForm : public BaseDialog {
private:
	TwrWnd *editFx1;
	TwrWnd *editFx2;
	TwrWnd *chkFx1;
	TwrWnd *chkFx2;
	TwrWnd *ignoreToolbarFx1;
	TwrWnd *ignoreToolbarFx2;
	TwrWnd *ignorePlaces;
	TwrWnd *optimizeFx1;	// IDC_CHECK_FX_OPTIMIZE1
	TwrWnd *optimizeFx2;	// IDC_CHECK_FX_OPTIMIZE2

	tstring GetMozFireBookmark(HWND hWnd,TCHAR *appProfile,int type,int pos);
	tstring getMozFireProfile(
		HWND hWnd,
		const TCHAR *profileDir,
		const TCHAR *appProfile,
		const TCHAR *profiles,
		const TCHAR *section,
		int type,
		int pos);

	void OnBnClickedButtonsearchfx31();
	void OnBnClickedButtonsearchfx32();
	void OnBnClickedReffx1();
	void OnBnClickedReffx2();

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_FxBM1;
	// ubN}[Ñt@C2
	tstring m_FxBM2;
	BOOL m_chkFx1;
	BOOL m_chkFx2;
	BOOL m_chkIEfav1;
	BOOL m_chkIEfav2;
	// ubN}[Nc[o[𖳎邩ǂ1
	BOOL m_chkIgnoreToolbar1;
	// ubN}[Nc[o[𖳎邩ǂ2
	BOOL m_chkIgnoreToolbar2;
	// œK邩ǂ1
	BOOL m_chkOptimize1;
	// œK邩ǂ2
	BOOL m_chkOptimize2;
	// X}[gubN}[N𑼂̃uEŨubN}[Nɏo͂邩ǂ
	BOOL m_placesPut;

	CFxForm(HWND parent, int resource);
	~CFxForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchFx1(HWND hWnd);
	void searchFx2(HWND hWnd);

};

#endif // SFFORM_H

